<template>
    <div class="row match-height">
        <div class="col-xl-12 col-lg-12">
            <ul class="nav nav-tabs nav-topline nav-justified" role="tablist">
    			<li class="nav-item">
    				<a class="nav-link active show" href="#tabs-1-tab-1" role="tab" data-toggle="tab" aria-expanded="true">
    					<span class="nav-link-in">
    						<i class="fa fa-shield"></i>
    						Motoristas
    					</span>
    				</a>
    			</li>
                <li class="nav-item">
                    <a class="nav-link" href="#tabs-1-tab-2" role="tab" data-toggle="tab" aria-expanded="false">
                        <span class="nav-link-in">
                            <i class="fa fa-shield"></i>
                            Viagens
                        </span>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#tabs-1-tab-3" role="tab" data-toggle="tab" aria-expanded="false">
                        <span class="nav-link-in">
                            <i class="fa fa-shield"></i>
                            Motoristas sem cargas
                        </span>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#tabs-1-tab-4" role="tab" data-toggle="tab" aria-expanded="false">
                        <span class="nav-link-in">
                            <i class="fa fa-shield"></i>
                            Carregados - Estatísticas
                        </span>
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#tabs-1-tab-5" role="tab" data-toggle="tab" aria-expanded="false">
                        <span class="nav-link-in">
                            <i class="fa fa-users"></i>
                            Listagem por tipo
                        </span>
                    </a>
                </li>
			</ul>

            <div class="tab-content card">
    			<div class="tab-pane active show" id="tabs-1-tab-1" role="tabpanel" aria-expanded="true">
                    <div class="content-body" v-bind:class="{ fullscreen_expand: isFullscreen }">
                        <div class="row match-height">
                            <div class="col-xl-12 col-lg-12">
                                <div class="card" style="">
                                    <div class="card-header">
                                        <h4 class="card-title">Motoristas</h4>
                                        <a class="heading-elements-toggle"><i class="fa fa-ellipsis-v font-medium-3"></i></a>
                                        <div class="heading-elements">
                                            <ul class="list-inline mb-0">
                                                <li><a @click="onCreate()" v-b-tooltip title="Cadastrar"><i class="fa fa-plus"></i></a></li>
                                                <li><a @click="onFilterReset()" v-b-tooltip title="Atualizar listagem"><i class="ft-rotate-cw"></i></a></li>
                                                <li><a @click="expandFullscreen()" v-b-tooltip title="Expande a tela" v-if="!isFullscreen"><i class="ft-maximize"></i></a></li>
                                                <li><a @click="expandFullscreen()" v-b-tooltip title="Minimiza a tela" v-if="isFullscreen"><i class="ft-minimize"></i></a></li>
                                                <li><a @click="onFilterShowHide()" v-b-tooltip.hover.left="'Filtros'"><i class="fa fa-filter"></i></a></li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="card-content">
                                        <div class="table-responsive">
                                            <div v-if="vuetableFilterRow">
                                                <vuetable-motoristas-filterbar>
                                                </vuetable-motoristas-filterbar>
                                            </div>
                                            <div class="loadingDataPosition">
                                                <div class="loadingData" v-if="loadingData"><div class="loadingDataSpinner"><spinner v-if="loadingData" text-fg-color="#ffffff" message="Carregando..."></spinner></div></div>
                                                <vuetable ref="vuetable"
                                                        api-url="/api/motoristas"
                                                        :fields="fields"
                                                        :css="css"
                                                        :append-params="moreParams"
                                                        track-by="motoristas_id"
                                                        pagination-path=""
                                                        @vuetable:load-error="onError"
                                                        @vuetable:pagination-data="onPaginationData"
                                                        @vuetable:loaded="onLoaded"
                                                      >
                                                      <template slot="sexo" scope="props">
                                                          <span class="badge badge-success" v-if="props.rowData.sexo.valor==1">{{ props.rowData.sexo.descr }}</span>
                                                          <span class="badge badge-info" v-if="props.rowData.sexo.valor==2">{{ props.rowData.sexo.descr }}</span>
                                                      </template>

                                                      <template slot="veiculo_proprio" scope="props">
                                                          <span class="badge badge-success" v-if="props.rowData.veiculo_proprio.valor==1">{{ props.rowData.veiculo_proprio.descr }}</span>
                                                          <span class="badge badge-warning" v-if="props.rowData.veiculo_proprio.valor==2">{{ props.rowData.veiculo_proprio.descr }}</span>
                                                      </template>

                                                      <template slot="tp_cnh" scope="props">
                                                          <span class="badge badge-info">{{ props.rowData.tp_cnh.descr }}</span>
                                                      </template>

                                                      <template slot="actions" scope="props">
                                                        <div class="custom-actions">
                                                            <a @click="onEdit(props.rowData, props.rowIndex)" v-b-tooltip title="Editar"><i class="fa fa-edit"></i></a>
                                                          </button>
                                                        </div>
                                                      </template>
                                                </vuetable>
                                            </div>
                                            <div class='col-md-12'>
                                                <div class="pull-left pagination-detail">
                                                    <vuetable-pagination-info ref="paginationInfo"
                                                                              :css="css.pagination"
                                                                              info-class="pull-left"
                                                    ></vuetable-pagination-info>
                                                </div>
                                                <div class="pull-right m-a-0">
                                                    <vuetable-pagination ref="pagination"
                                                                         :css="css.pagination"
                                                                         @vuetable-pagination:change-page="onChangePage"
                                                    ></vuetable-pagination>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="tab-pane" id="tabs-1-tab-2" role="tabpanel" aria-expanded="true">
                    <div class="content-body" v-bind:class="{ fullscreen_expand: isFullscreen }">
                        <div class="row match-height">
                            <div class="col-xl-12 col-lg-12">
                                <div class="card" style="">
                                    <div class="card-header">
                                        <h4 class="card-title">Viagens</h4>
                                        <a class="heading-elements-toggle"><i class="fa fa-ellipsis-v font-medium-3"></i></a>
                                        <div class="heading-elements">
                                            <ul class="list-inline mb-0">
                                                <li><a @click="onCreateViagem()" v-b-tooltip title="Cadastrar"><i class="fa fa-plus"></i></a></li>
                                                <li><a @click="onFilterReset()" v-b-tooltip title="Atualizar listagem"><i class="ft-rotate-cw"></i></a></li>
                                                <li><a @click="expandFullscreen()" v-b-tooltip title="Expande a tela" v-if="!isFullscreen"><i class="ft-maximize"></i></a></li>
                                                <li><a @click="expandFullscreen()" v-b-tooltip title="Minimiza a tela" v-if="isFullscreen"><i class="ft-minimize"></i></a></li>
                                                <li><a @click="onFilterShowHide()" v-b-tooltip.hover.left="'Filtros'"><i class="fa fa-filter"></i></a></li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="card-content">
                                        <div class="table-responsive">
                                            <div v-if="vuetableFilterRow">
                                                <vuetable-viagens-filterbar>
                                                </vuetable-viagens-filterbar>
                                            </div>
                                            <div class="loadingDataPosition">
                                                <div class="loadingData" v-if="loadingData"><div class="loadingDataSpinner"><spinner v-if="loadingData" text-fg-color="#ffffff" message="Carregando..."></spinner></div></div>
                                                <vuetable ref="vuetable_viagem"
                                                        api-url="/api/viagens"
                                                        :fields="fieldsViagem"
                                                        :css="css"
                                                        :append-params="moreParams"
                                                        track-by="viagens_id"
                                                        pagination-path=""
                                                        @vuetable:load-error="onError"
                                                        @vuetable:pagination-data="onPaginationData"
                                                        @vuetable:loaded="onLoaded"
                                                      >
                                                      <template slot="esta_carregado" scope="props">
                                                          <span class="badge badge-success" v-if="props.rowData.esta_carregado.valor==1">{{ props.rowData.esta_carregado.descr }}</span>
                                                          <span class="badge badge-info" v-if="props.rowData.esta_carregado.valor==2">{{ props.rowData.esta_carregado.descr }}</span>
                                                      </template>

                                                      <template slot="tp_viagem" scope="props">
                                                          <span class="badge badge-success" v-if="props.rowData.tp_viagem.valor==1">{{ props.rowData.tp_viagem.descr }}</span>
                                                          <span class="badge badge-warning" v-if="props.rowData.tp_viagem.valor==2">{{ props.rowData.tp_viagem.descr }}</span>
                                                      </template>

                                                      <template slot="tipo_veiculo" scope="props">
                                                          <span class="badge badge-info">{{ props.rowData.tipo_veiculo.descr }}</span>
                                                      </template>

                                                      <template slot="motoristas" scope="props">
                                                          <span class="badge badge-success">{{ props.rowData.motoristas.nome }}</span>
                                                      </template>

                                                      <template slot="actions" scope="props">
                                                        <div class="custom-actions">
                                                            <a @click="onEdit(props.rowData, props.rowIndex)" v-b-tooltip title="Editar"><i class="fa fa-edit"></i></a>
                                                          </button>
                                                        </div>
                                                      </template>
                                                </vuetable>
                                            </div>
                                            <div class='col-md-12'>
                                                <div class="pull-left pagination-detail">
                                                    <vuetable-pagination-info ref="paginationInfo"
                                                                              :css="css.pagination"
                                                                              info-class="pull-left"
                                                    ></vuetable-pagination-info>
                                                </div>
                                                <div class="pull-right m-a-0">
                                                    <vuetable-pagination ref="pagination"
                                                                         :css="css.pagination"
                                                                         @vuetable-pagination:change-page="onChangePage"
                                                    ></vuetable-pagination>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div role="tabpanel" class="tab-pane fade" id="tabs-1-tab-3" aria-expanded="true">
                    <div class="row match-height" v-bind:class="{ fullscreen_expand: isFullscreen }">
                        <div class="col-xl-12 col-lg-12">
                            <div class="card" style="">
                                <div class="card-header">
                                    <h4 class="card-title">Motoristas sem viagem</h4>
                                    <a class="heading-elements-toggle"><i class="fa fa-ellipsis-v font-medium-3"></i></a>
                                    <div class="heading-elements">
                                        <ul class="list-inline mb-0">
                                            <li><a @click="onFilterReset()" v-b-tooltip title="Atualizar"><i class="ft-rotate-cw"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Expande a tela" v-if="!isFullscreen"><i class="ft-maximize"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Minimiza a tela" v-if="isFullscreen"><i class="ft-minimize"></i></a></li>
                                        </ul>
                                    </div>
                                </div>
                                <div class="card-content">
                                    <div class="table-responsive">
                                        <div v-if="vuetableFilterRow">
                                            <vuetable-motoristas-sem-viagens-filterbar>
                                            </vuetable-motoristas-sem-viagens-filterbar>
                                        </div>
                                        <div class="loadingDataPosition">
                                            <div class="loadingData" v-if="loadingData"><div class="loadingDataSpinner"><spinner v-if="loadingData" text-fg-color="#ffffff" message="Carregando..."></spinner></div></div>
                                            <vuetable ref="vuetable_motorista_viagem"
                                                    api-url="/api/motoristas/semcarga"
                                                    :fields="fieldsViagem"
                                                    :css="css"
                                                    :append-params="moreParams"
                                                    track-by="viagens_id"
                                                    pagination-path=""
                                                    @vuetable:load-error="onError"
                                                    @vuetable:pagination-data="onPaginationData"
                                                    @vuetable:loaded="onLoaded"
                                                  >
                                                  <template slot="esta_carregado" scope="props">
                                                      <span class="badge badge-success" v-if="props.rowData.esta_carregado.valor==1">{{ props.rowData.esta_carregado.descr }}</span>
                                                      <span class="badge badge-info" v-if="props.rowData.esta_carregado.valor==2">{{ props.rowData.esta_carregado.descr }}</span>
                                                  </template>

                                                  <template slot="tp_viagem" scope="props">
                                                      <span class="badge badge-success" v-if="props.rowData.tp_viagem.valor==1">{{ props.rowData.tp_viagem.descr }}</span>
                                                      <span class="badge badge-warning" v-if="props.rowData.tp_viagem.valor==2">{{ props.rowData.tp_viagem.descr }}</span>
                                                  </template>

                                                  <template slot="tipo_veiculo" scope="props">
                                                      <span class="badge badge-info">{{ props.rowData.tipo_veiculo.descr }}</span>
                                                  </template>

                                                  <template slot="motoristas" scope="props">
                                                      <span class="badge badge-success">{{ props.rowData.motoristas.nome }}</span>
                                                  </template>
                                            </vuetable>
                                        </div>
                                        <div class='col-md-12'>
                                            <div class="pull-left pagination-detail">
                                                <vuetable-pagination-info ref="paginationInfo"
                                                                          :css="css.pagination"
                                                                          info-class="pull-left"
                                                ></vuetable-pagination-info>
                                            </div>
                                            <div class="pull-right m-a-0">
                                                <vuetable-pagination ref="pagination"
                                                                     :css="css.pagination"
                                                                     @vuetable-pagination:change-page="onChangePage"
                                                ></vuetable-pagination>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>


                <div role="tabpanel" class="tab-pane fade" id="tabs-1-tab-4" aria-expanded="true">
                    <div class="row match-height" v-bind:class="{ fullscreen_expand: isFullscreen }">
                        <div class="col-xl-12 col-lg-12">
                            <div class="card" style="">
                                <div class="card-header">
                                    <h4 class="card-title">Carregados</h4>
                                    <a class="heading-elements-toggle"><i class="fa fa-ellipsis-v font-medium-3"></i></a>
                                    <div class="heading-elements">
                                        <ul class="list-inline mb-0">
                                            <li><a @click="onFilterReset()" v-b-tooltip title="Atualizar"><i class="ft-rotate-cw"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Expande a tela" v-if="!isFullscreen"><i class="ft-maximize"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Minimiza a tela" v-if="isFullscreen"><i class="ft-minimize"></i></a></li>
                                        </ul>
                                    </div>
                                </div>
                                <div class="card-content">
                                    <div class="table-responsive">
                                        <div class="loadingDataPosition">
                                            <div class="loadingData" v-if="loadingData"><div class="loadingDataSpinner"><spinner v-if="loadingData" text-fg-color="#ffffff" message="Carregando..."></spinner></div></div>
                                            <vuetable ref="vuetable_viagem_carregados_viagem"
                                                    api-url="/api/viagens/carregados"
                                                    :fields="fieldsCarregados"
                                                    :css="css"
                                                    :append-params="moreParams"
                                                    track-by="viagens_id"
                                                    pagination-path=""
                                                    @vuetable:load-error="onError"
                                                    @vuetable:loaded="onLoaded"
                                                  >
                                            </vuetable>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div role="tabpanel" class="tab-pane fade" id="tabs-1-tab-5" aria-expanded="true">
                    <div class="row match-height" v-bind:class="{ fullscreen_expand: isFullscreen }">
                        <div class="col-xl-12 col-lg-12">
                            <div class="card" style="">
                                <div class="card-header">
                                    <h4 class="card-title">Por tipo</h4>
                                    <a class="heading-elements-toggle"><i class="fa fa-ellipsis-v font-medium-3"></i></a>
                                    <div class="heading-elements">
                                        <ul class="list-inline mb-0">
                                            <li><a @click="onFilterReset()" v-b-tooltip title="Atualizar"><i class="ft-rotate-cw"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Expande a tela" v-if="!isFullscreen"><i class="ft-maximize"></i></a></li>
                                            <li><a @click="expandFullscreen()" v-b-tooltip title="Minimiza a tela" v-if="isFullscreen"><i class="ft-minimize"></i></a></li>
                                        </ul>
                                    </div>
                                </div>
                                <div class="card-content">
                                    <div class="table-responsive">
                                        <div class="loadingDataPosition">
                                            <div class="loadingData" v-if="loadingData"><div class="loadingDataSpinner"><spinner v-if="loadingData" text-fg-color="#ffffff" message="Carregando..."></spinner></div></div>
                                            <vuetable ref="vuetable_viagem_tipo_veiculo"
                                                    api-url="/api/viagens/tipoveiculo"
                                                    :fields="fieldsPorTipo"
                                                    :css="css"
                                                    :append-params="moreParams"
                                                    track-by="viagens_id"
                                                    pagination-path=""
                                                    @vuetable:load-error="onError"
                                                    @vuetable:loaded="onLoaded"
                                                  >
                                            </vuetable>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
    		</div>
        </div>

        <b-modal id="modal_form"
                 ref="modal_form"
                 :title="modal_titulo"
                 :ok-title="modal_botao"
                 close-title="Fechar"
                 cancel-title="Cancelar"
                 :ok-disabled=form.errors.any()
                 v-model="showModal"
                 @ok="handleOk">
            <form @submit.stop.prevent="handleOk" @keydown="form.errors.clear($event.target.name)">
                <label for="nome">Nome</label>
                <b-form-input type="text"
                             placeholder="Nome"
                             v-model="form.nome">
                </b-form-input>
                <b-form-feedback v-text="form.errors.get('nome')" v-if="form.errors.has('nome')"></b-form-feedback>

                <label for="dt_nascto">Data de nascimento</label>
                <b-form-input type="text"
                             placeholder="Data de nascimento"
                             v-mask="'##/##/####'"
                             v-model="form.dt_nascto">
                </b-form-input>
                <b-form-feedback v-text="form.errors.get('dt_nascto')" v-if="form.errors.has('dt_nascto')"></b-form-feedback>

                <b-form-text tag="div">Sexo</b-form-text>
                <multiselect v-model="form.sexo"
                :options="optionsLivSexo"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form.errors.get('sexo.value')" v-if="form.errors.has('sexo.value')"></b-form-feedback>

                <b-form-text tag="div">Veículo próprio ?</b-form-text>
                <multiselect v-model="form.veiculo_proprio"
                :options="optionsLivVeiculoProprio"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form.errors.get('veiculo_proprio.value')" v-if="form.errors.has('veiculo_proprio.value')"></b-form-feedback>

                <b-form-text tag="div">Tipo CNH</b-form-text>
                <multiselect v-model="form.tp_cnh"
                :options="optionsLivTpCnh"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form.errors.get('tp_cnh.value')" v-if="form.errors.has('tp_cnh.value')"></b-form-feedback>
            </form>
            <div slot="modal-footer" class="w-100">
                 <div class="float-left"><spinner v-if="loading" message="Processando..."></spinner></div>
                 <div class="float-right">
                     <b-btn @click="showModal=false" variant="secondary">
                       Fechar
                     </b-btn>
                     <b-btn @click="handleOk($event)" variant="secondary" :disabled="isDisabled">
                       Enviar
                     </b-btn>
                 </div>
            </div>
        </b-modal>

        <b-modal id="modal_viagem_form"
                 ref="modal_viagem_form"
                 :title="modal_titulo"
                 :ok-title="modal_botao"
                 close-title="Fechar"
                 cancel-title="Cancelar"
                 :ok-disabled=form_viagem.errors.any()
                 v-model="showModalViagem"
                 @ok="handleOkViagem">
            <form @submit.stop.prevent="handleOkViagem" @keydown="form_viagem.errors.clear($event.target.name)">
                <label for="municipio_origem">Municipio Origem</label>
                <b-form-input type="text"
                             placeholder="Municipio Origem"
                             v-model="form_viagem.municipio_origem">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('municipio_origem')" v-if="form_viagem.errors.has('municipio_origem')"></b-form-feedback>

                <label for="latitude_origem">Latitude Origem</label>
                <b-form-input type="text"
                             placeholder="Latitude Origem"
                             v-model="form_viagem.latitude_origem">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('latitude_origem')" v-if="form_viagem.errors.has('latitude_origem')"></b-form-feedback>

                <label for="longitude_origem">Longitude Origem</label>
                <b-form-input type="text"
                             placeholder="Longitude Origem"
                             v-model="form_viagem.longitude_origem">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('longitude_origem')" v-if="form_viagem.errors.has('longitude_origem')"></b-form-feedback>

                <label for="municipio_destino">Municipio Destino</label>
                <b-form-input type="text"
                             placeholder="Municipio Destino"
                             v-model="form_viagem.municipio_destino">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('municipio_destino')" v-if="form_viagem.errors.has('municipio_destino')"></b-form-feedback>

                <label for="latitude_destino">Latitude Destino</label>
                <b-form-input type="text"
                             placeholder="Latitude Destino"
                             v-model="form_viagem.latitude_destino">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('latitude_origem')" v-if="form_viagem.errors.has('latitude_origem')"></b-form-feedback>

                <label for="longitude_origem">Longitude Destino</label>
                <b-form-input type="text"
                             placeholder="Longitude Destino"
                             v-model="form_viagem.longitude_destino">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('longitude_origem')" v-if="form_viagem.errors.has('longitude_origem')"></b-form-feedback>

                <label for="dt_nascto">Data de operação</label>
                <b-form-input type="text"
                             placeholder="Data de operação"
                             v-mask="'##/##/####'"
                             v-model="form_viagem.dt_viagem">
                </b-form-input>
                <b-form-feedback v-text="form_viagem.errors.get('dt_viagem')" v-if="form_viagem.errors.has('dt_viagem')"></b-form-feedback>

                <b-form-text tag="div">Tipo Viagem</b-form-text>
                <multiselect v-model="form_viagem.tp_viagem"
                :options="optionsLivTpViagem"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form_viagem.errors.get('tp_viagem.value')" v-if="form_viagem.errors.has('tp_viagem.value')"></b-form-feedback>

                <b-form-text tag="div">Está carregado ?</b-form-text>
                <multiselect v-model="form_viagem.esta_carregado"
                :options="optionsLivEstaCarregado"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form_viagem.errors.get('esta_carregado.value')" v-if="form_viagem.errors.has('esta_carregado.value')"></b-form-feedback>

                <b-form-text tag="div">Tipo Veículo</b-form-text>
                <multiselect v-model="form_viagem.tipvei"
                :options="optionsTipVei"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form_viagem.errors.get('tipvei.value')" v-if="form_viagem.errors.has('tipvei.value')"></b-form-feedback>

                <b-form-text tag="div">Motorista</b-form-text>
                <multiselect v-model="form_viagem.motoristas"
                :options="optionsMotoristas"
                track-by="value"
                label="label"
                :hide-selected="true"
                placeholder="Selecione"
                tag-placeholder="Selecionar"
                select-label="Selecionar"
                selected-label="Selecionado"
                deselect-label="Remover"
                ></multiselect>
                <b-form-feedback v-text="form_viagem.errors.get('motoristas.value')" v-if="form_viagem.errors.has('motoristas.value')"></b-form-feedback>
            </form>
            <div slot="modal-footer" class="w-100">
                 <div class="float-left"><spinner v-if="loading" message="Processando..."></spinner></div>
                 <div class="float-right">
                     <b-btn @click="showModalViagem=false" variant="secondary">
                       Fechar
                     </b-btn>
                     <b-btn @click="handleOkViagem($event)" variant="secondary" :disabled="isDisabled">
                       Enviar
                     </b-btn>
                 </div>
            </div>
        </b-modal>
    </div>
</template>
<script>
import moment from 'moment'
import Vuetable from '../components/Vuetable'
import VuetablePagination from '../components/VuetablePagination'
import VuetablePaginationInfo from '../components/VuetablePaginationInfo'
import ViagensFilterBar from './ViagensFilterBar'
import MotoristasFilterBar from './MotoristasFilterBar'
import MotoristasSemViagensFilterBar from './MotoristasSemViagensFilterBar'


export default {
    components: {
      Vuetable,
      VuetablePagination,
      VuetablePaginationInfo,
      'vuetable-motoristas-filterbar': MotoristasFilterBar,
      'vuetable-viagens-filterbar': ViagensFilterBar,
      'vuetable-motoristas-sem-viagens-filterbar': MotoristasSemViagensFilterBar,
    },

    data ()
    {
    return {
        modal_titulo: '',
        modal_botao: '',
        modal_acao: '',
        isFullscreen: false,
        loading: false,
        disabled: false,
        isDisabled: false,
        loadingData: true,
        showModal: false,
        showModalViagem: false,
        optionsLivSexo: [],
        optionsLivTpCnh: [],
        optionsLivVeiculoProprio: [],
        optionsLivTpViagem: [],
        optionsLivEstaCarregado: [],
        optionsTipVei: [],
        optionsMotoristas: [],
        form: new Form({ nome: '',
             dt_nascto: '',
             motoristas_id: '',
             sexo: [],
             veiculo_proprio: [],
             tp_cnh: []
         }),
        form_viagem: new Form({ municipio_origem: '',
              municipio_destino: '',
              latitude_origem: '',
              latitude_destino: '',
              longitude_origem: '',
              longitude_destino: '',
              dt_viagem: '',
              tipvei: [],
              motoristas: [],
              tp_viagem: [],
              esta_carregado: []
        }),
        fields: [
            {
                name: '__checkbox',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
            },
            {
                name: 'nome',
                title: 'Nome',
                sortField: 'nome'
            },
            {
                name: 'dt_nascto',
                title: 'Data de nascimento',
                sortField: 'dt_nascto',
                callback: 'formatDate|DD/MM/YYYY'
            },
            {
                name: '__slot:sexo',
                title: 'Sexo',
                sortField: 'sexo'
            },
            {
                name: '__slot:tp_cnh',
                title: 'Tipo CNH',
                sortField: 'tp_cnh'
            },
            {
                name: '__slot:veiculo_proprio',
                title: 'Veículo Próprio',
                sortField: 'veiculo_proprio'
            },
            {
                name: '__slot:actions',   // <----
                title: 'Ações',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
            }
        ],
        fieldsCarregados: [
            {
                name: 'total_dia',
                title: 'Total carregado dia',
                sortField: 'total_dia'
            },
            {
                name: 'total_semana',
                title: 'Total carregado semana',
                sortField: 'total_semana'
            },
            {
                name: 'total_mes',
                title: 'Total carregado mês',
                sortField: 'total_mes'
            },
        ],
        fieldsPorTipo: [
            {
                name: 'municipio_origem',
                title: 'Municipio Origem',
                sortField: 'municipio_origem'
            },
            {
                name: 'municipio_destino',
                title: 'Municipio Destino',
                sortField: 'municipio_destino'
            },
            {
                name: 'descr',
                title: 'Tipo Veiculo',
                sortField: 'descr'
            },
            {
                name: 'total',
                title: 'Total',
                sortField: 'total'
            },
        ],
        fieldsViagem: [
            {
                name: 'dt_viagem',
                title: 'Data Viagem',
                sortField: 'dt_viagem',
                callback: 'formatDate|DD/MM/YYYY'
            },
            {
                name: 'municipio_origem',
                title: 'Municipio Origem',
                sortField: 'municipio_origem'
            },
            {
                name: 'latitude_origem',
                title: 'Latitude Origem',
                sortField: 'latitude_origem'
            },
            {
                name: 'longitude_origem',
                title: 'Longitude Origem',
                sortField: 'longitude_origem'
            },
            {
                name: 'municipio_destino',
                title: 'Municipio Destino',
                sortField: 'municipio_destino',
            },
            {
                name: 'latitude_destino',
                title: 'Latitude Destino',
                sortField: 'latitude_destino'
            },
            {
                name: 'longitude_destino',
                title: 'Longitude Destino',
                sortField: 'longitude_destino'
            },
            {
                name: '__slot:esta_carregado',
                title: 'Esta Carregado',
                sortField: 'esta_carregado'
            },
            {
                name: '__slot:tp_viagem',
                title: 'Tipo Viagem',
                sortField: 'tp_viagem'
            },
            {
                name: '__slot:tipo_veiculo',
                title: 'Tipo Veiculo',
                sortField: 'tipo_veiculo'
            },
            {
                name: '__slot:motoristas',
                title: 'Motorista',
                sortField: 'motoristas'
            },
        ],
        css: {
        loadingClass: 'loading',
        ascendingIcon: 'glyphicon glyphicon-chevron-up',
        descendingIcon: 'glyphicon glyphicon-chevron-down',
        handleIcon: 'glyphicon glyphicon-menu-hamburger',
        },
        helpForm: new Form({statusRecord: [], params: [],search:'', status: ''}),
        moreParams: {}
        }
    },
    mounted() {
        this.$events.$on('filter-viagens-set', eventData => this.onFilterSetViagens(eventData));
        this.$events.$on('filter-viagens-reset', e => this.onFilterResetViagens());
        this.$events.$on('filter-motoristas-set', eventData => this.onFilterSetMotoristas(eventData));
        this.$events.$on('filter-motoristas-reset', e => this.onFilterResetMotoristas());
        this.$events.$on('filter-motoristas-sem-viagens-set', eventData => this.onFilterSetMotoristasSemViagens(eventData));
        this.$events.$on('filter-motoristas-sem-viagens-reset', e => this.onFilterResetMotoristasSemViagens());
        this.getLivGeral();
    },
    methods: {
        expandFullscreen() {
        this.isFullscreen = !this.isFullscreen;
        },
        onPaginationData (paginationData) {
          this.$refs.pagination.setPaginationData(paginationData)
          this.$refs.paginationInfo.setPaginationData(paginationData)
        },
        onChangePage (page) {
          this.$refs.vuetable.changePage(page)
        },
        onFilterSetMotoristas (data_filter) {
            this.loadingData = true;
            this.moreParams = {
                'nome': data_filter.nome,
                'veiculo_proprio': data_filter.veiculo_proprio,
            }
            Vue.nextTick( () => {this.$refs.vuetable.reload(); })
        },
        onFilterResetMotoristas () {
            this.loadingData = true;
            this.moreParams = {}
            Vue.nextTick( () => this.$refs.vuetable.refresh())
        },
        onFilterSetViagens (data_filter) {
            this.loadingData = true;
            this.moreParams = {
                'nome': data_filter.nome,
            }
            Vue.nextTick( () => {this.$refs.vuetable_viagem.reload(); })
        },
        onFilterResetViagens () {
            this.loadingData = true;
            this.moreParams = {}
            Vue.nextTick( () => this.$refs.vuetable_viagem.refresh())
        },
        onFilterSetMotoristasSemVi (data_filter) {
            this.loadingData = true;
            this.moreParams = {
                'nome': data_filter.nome,
            }
            Vue.nextTick( () => {this.$refs.vuetable_motorista_viagem.reload(); })
        },
        onFilterResetMotoristasSemViagens () {
            this.loadingData = true;
            this.moreParams = {}
            Vue.nextTick( () => this.$refs.vuetable_motorista_viagem.refresh())
        },
        onFilterShowHide() {
            if(this.vuetableFilterRow)
            {
                this.$store.commit('setVuetableFilterRow', false);
            }
            else
            {
                this.$store.commit('setVuetableFilterRow', true);
            }
        },
        onLoaded: function () {
            this.dataExport = this.$refs.vuetable.tableData;
            this.loadingData = false;
            this.$store.commit('setVuetableFilterButton', false);
        },
        formatDate (value, fmt = 'DD MM YYYY') {
          return (value == null)
            ? ''
            : moment(value, 'YYYY/MM/DD').format(fmt)
        },
        handleOk(e)
        {
            e.preventDefault();
            if(this.modal_acao=="i")
            {
               this.onStore();
            }
            else
            {
                this.onUpdate(this.form.motoristas_id);
            }
        },
        handleOkViagem(e)
        {
            e.preventDefault();
            if(this.modal_acao=="i")
            {
               this.onStoreViagem();
            }
            else
            {
                this.onUpdateViagem(this.form.viagens_id);
            }
        },
        onCreate ()
        {
          this.isDisabled = false;
          this.loading = false;
          this.modal_titulo = "Cadastrar";
          this.modal_botao = "Cadastrar";
          this.modal_acao = "i";
          this.form.reset();
          this.$refs.modal_form.show();
        },
        onCreateViagem ()
        {
          this.isDisabled = false;
          this.loading = false;
          this.modal_titulo = "Cadastrar";
          this.modal_botao = "Cadastrar";
          this.modal_acao = "i";
          this.form_viagem.reset();
          this.$refs.modal_viagem_form.show();
        },
        onEdit (data, index)
        {
          this.isDisabled = false;
          this.loading = false;
          this.modal_titulo = "Alterar";
          this.modal_botao = "Alterar";
          this.modal_acao = "u";
          this.form.reset();
          this.form.nome = data.nome;
          this.form.dt_nascto = this.formatDate(data.dt_nascto);
          this.form.sexo = { label: data.sexo.descr, value: data.sexo.valor };
          this.form.tp_cnh = { label: data.tp_cnh.descr, value: data.tp_cnh.valor };
          this.form.veiculo_proprio = { label: data.veiculo_proprio.descr, value: data.veiculo_proprio.valor };
          this.form.motoristas_id = data.motoristas_id;
          this.$refs.modal_form.show();
        },
        onEditViagem (data, index)
        {
          this.isDisabled = false;
          this.loading = false;
          this.modal_titulo = "Alterar";
          this.modal_botao = "Alterar";
          this.modal_acao = "u";
          this.form_viagem.reset();
          this.form_viagem.municipio_origem = data.municipio_origem;
          this.form_viagem.latitude_origem = data.latitude_origem;
          this.form_viagem.longitude_origem = data.longitude_origem;
          this.form_viagem.municipio_destino = data.municipio_destino;
          this.form_viagem.latitude_destino = data.latitude_destino;
          this.form_viagem.longitude_destino = data.longitude_destino;
          this.form_viagem.tipvei = { label: data.tipvei.descr, value: data.tipvei.tipvei_id };
          this.form_viagem.tp_viagem = { label: data.tp_viagem.descr, value: data.tp_viagem.valor };
          this.form_viagem.esta_carregado = { label: data.esta_carregado.descr, value: data.esta_carregado.valor };
          this.form_viagem.viagens_id = data.viagens_id;
          this.$refs.modal_viagem_form.show();
        },
        onStore()
        {
            this.loading = true;
            this.isDisabled = true;
            this.form.post('/api/motoristas/store').then(response =>
            {
                Vue.nextTick( () => {this.$refs.vuetable.reload(); })
                new ReturnApi(response, this)
            })
            .catch(errors =>
            {
                new ReturnApi(errors, this)
            });
        },
        onUpdate(id)
        {
            this.loading = true;
            this.isDisabled = true;
            this.form.post('/api/motoristas/update/'+id).then(response =>
            {
                Vue.nextTick( () => {this.$refs.vuetable.reload(); })
                new ReturnApi(response, this)
            })
            .catch(errors =>
            {
                new ReturnApi(errors, this)
            });
        },
        onStoreViagem()
        {
            this.loading = true;
            this.isDisabled = true;
            this.form_viagem.post('/api/viagens/store').then(response =>
            {
                Vue.nextTick( () => {this.$refs.vuetable_viagem.reload(); })
                Vue.nextTick( () => {this.$refs.vuetable_motorista_viagem.reload(); })
                Vue.nextTick( () => {this.$refs.vuetable_viagem_tipo_veiculo.reload(); })
                Vue.nextTick( () => {this.$refs.vuetable_viagem_carregados_viagem.reload(); })
                new ReturnApi(response, this)
            })
            .catch(errors =>
            {
                new ReturnApi(errors, this)
            });
        },
        onUpdateViagem(id)
        {
            this.loading = true;
            this.isDisabled = true;
            this.form_viagem.post('/api/viagens/update/'+id).then(response =>
            {
                new ReturnApi(response, this)
            })
            .catch(errors =>
            {
                new ReturnApi(errors, this)
            });
        },
        onFormataCnpj(cnpj_base, cnpj_filial, cnpj_digito)
        {
            var cnpj_formatado
            var pad = "00000000"
            var cnpj_base = pad.substring(0, pad.length - cnpj_base.length) + cnpj_base;
            var pad = "0000"
            var cnpj_filial = pad.substring(0, pad.length - cnpj_filial.length) + cnpj_filial;
            var pad = "00"
            var cnpj_digito = pad.substring(0, pad.length - cnpj_digito.length) + cnpj_digito;

            return cnpj_base+""+cnpj_filial+""+cnpj_digito;
        },
        getLivGeral() {
            this.helpForm.get('/api/motoristas/jsonlistgeral').then(response =>
            {
                new ReturnApi(response, this, true, false, false);
                response.sexo.forEach((obj)=>
                {
                    this.optionsLivSexo.push({ label: obj.descr, value: obj.valor })
                })

                response.tp_cnh.forEach((obj)=>
                {
                    this.optionsLivTpCnh.push({ label: obj.descr, value: obj.valor })
                })

                response.veiculo_proprio.forEach((obj)=>
                {
                    this.optionsLivVeiculoProprio.push({ label: obj.descr, value: obj.valor })
                })

                response.esta_carregado.forEach((obj)=>
                {
                    this.optionsLivEstaCarregado.push({ label: obj.descr, value: obj.valor })
                })

                response.tp_viagem.forEach((obj)=>
                {
                    this.optionsLivTpViagem.push({ label: obj.descr, value: obj.valor })
                })

                response.tipvei.forEach((obj)=>
                {
                    this.optionsTipVei.push({ label: obj.descr, value: obj.tipvei_id })
                })

                response.motoristas.forEach((obj)=>
                {
                    this.optionsMotoristas.push({ label: obj.nome, value: obj.motoristas_id })
                })

            })
            .catch(errors =>
            {
                new ReturnApi(errors, this)
            });
        },
        onError(response) {
            new ReturnApi(response.response, this, true, true, false);
        },
    },
    computed: {
        vuetableFilterRow: {
          get () {
            return this.$store.state.vuetable.filterRow;
          },
        },
        isLoaded: {
            get() {
                return this.$store.getters.isloaded;
            }
        }
    }
}
</script>
